/*
 * LLHTDist.h
 *
 *  Created on: Jun 21, 2010
 *      Author: Majid Kazemian
 *      Email : akazemi2@uiuc.edu
 */

#ifndef LLHTDIST_H_
#define LLHTDIST_H_

using namespace std;
#include <map>
#include <vector>
#include <string>
#include <iostream.h>
#include <fstream.h>
#include <math.h>
#include <algorithm>

#define MAX_LINE 1000
#define NEGINF log(0)

class LLHTDist {
	public:
		LLHTDist(char* universe_file, char* geneset_file, char* sample_file, char* cond_geneset=NULL, bool use_uniform_weights=false);
		~LLHTDist();
		long double get_significance();
		long double get_cond_significance();
	private:
		map<string, long double> universe_map;
		map<string, long double> geneset_map;
		map<string, long double> sample_map;
		map<string, long double> cond_gs_map;
		long double Sample_prob(map<string, long double> , int sample_size, long double **dp_table); //dynamic programming
		long double LogSum (long double x, long double y); //calculate the logsum

};

#endif /* LLHTDIST_H_ */
